package issueData;

import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class IssueWriter {

    private Issue issue;

    public IssueWriter(Issue issue) {
        this.issue = issue;
    }


    public void write() {
        String path = "/home/jack/Documents/testrepo/.issues/" + issue.getOriginalHash() + "/";
        Path commentDir = Paths.get(path + "comments/");

        try {
            Files.createDirectories(commentDir);

            ObjectMapper mapper = new ObjectMapper();

            mapper.writeValue(new File(path + "title"), issue.getTitle());
            mapper.writeValue(new File(path + "description"), issue.getDescription());
            mapper.writeValue(new File(path + "creator"), issue.getCreator());
            mapper.writeValue(new File(path + "status"), issue.isopen());
            mapper.writeValue(new File(path + "creationTime"), issue.getCreationTime());
            mapper.writeValue(new File(path + "editedTime"), issue.getEdited());

            for (Comment comment : issue.getComments()) {
                String commentPath = commentDir + "/" + comment.getHash() + "/";
                Files.createDirectories(Paths.get(commentPath));
                mapper.writeValue(new File(commentPath + "author"), comment.getAuthor());
                mapper.writeValue(new File(commentPath + "message"), comment.getMessage());
                mapper.writeValue(new File(commentPath + "creationTime"), comment.getCreationTime());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }


}
